<template>
  <q-page>
    <div class="row justify-end q-pa-md">
      <q-btn outline color="grey-7" class="q-mx-sm " icon="arrow_back" rounded @click="back()">voltar</q-btn>
      <q-btn rounded color="primary" label="Nova Transação" @click="transaction()" />
    </div>
    <custom-table
      :templateColumns="templateColumns"
      :loadingTable="loadingTable"
      :data="data"
      :columns="columns"
      :visibleColumns="visibleColumns"
      :fullscreen="false"
      :visibleButtonRegister="false"
      :visibleControlColumns="true"
      component="parceiro"
    >
      <template slot="acoes" slot-scope="props" :props="props">
        <q-btn-dropdown outline color="primary" icon="settings">
          <q-list>
            <q-item
              clickable
              v-close-popup
              tag="label"
              @click="editTransaction(props.props.row.id, 'editar')"
            >
              <q-item-section avatar>
                <q-avatar icon="edit" />
              </q-item-section>
              <q-item-section class="text-right">
                <q-item-label>Editar</q-item-label>
              </q-item-section>
            </q-item>

            <q-item v-close-popup multiline tag="label" v-ripple>
              <q-item-section avatar>
                <q-toggle
                  @input="updateStatus(props.props.row)"
                  color="green"
                  v-model="props.props.row.status"
                  val="friend"
                />
              </q-item-section>
              <q-item-section class="text-right">
                <q-item-label>Status</q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-btn-dropdown>
      </template>
    </custom-table>
  </q-page>
</template>

<script>
import Transaction from '@services/transaction/Transaction'
import CustomTable from 'components/custom-table.vue'
import Notify from '@mixins/notify.mixin'
export default {
  components: {
    'custom-table': CustomTable
  },
  mixins: [Notify],
  data () {
    return {
      Transaction: new Transaction(),
      loadingTable: false,
      status: '',
      data: [],
      visibleColumns: [
        'codigoTransacao',
        'descricaoTransacao',
        'endPoint',
        'enderecoFila',
        'topicoFila',
        'status',
        'acoes'
      ],
      columns: [
        {
          align: 'left',
          name: 'codigoTransacao',
          label: 'Cód. Transação',
          field: 'codigoTransacao',
          sortable: true
        },
        {
          align: 'left',
          name: 'descricaoTransacao',
          label: 'Descrição',
          field: 'descricaoTransacao',
          sortable: true
        },
        {
          align: 'left',
          name: 'endPoint',
          label: 'Endpoint',
          field: 'endPoint',
          sortable: true
        },
        {
          align: 'left',
          name: 'enderecoFila',
          label: 'Enderaço na Fila',
          field: 'enderecoFila',
          sortable: true
        },
        {
          align: 'left',
          name: 'topicoFila',
          label: 'Tópico da Fila',
          field: 'topicoFila',
          sortable: true
        },
        {
          align: 'left',
          name: 'status',
          label: 'Status',
          field: 'status',
          sortable: true
        },
        {
          align: 'left',
          name: 'acoes',
          label: 'Ações',
          field: 'Acoes',
          sortable: false,
          class: 'fixed-col'
        }
      ],
      templateColumns: [
        {
          columnName: 'acoes'
        }
      ]
    }
  },
  mounted () {
    this.getTransaction()
  },
  methods: {
    getTransaction () {
      this.$q.loading.show()
      this.Transaction.list()
        .then(resp => {
          this.data = resp.data
        })
        .catch(err => {
          this.NotifyDanger(err.message)
        })
        .finally(() => this.$q.loading.hide())
    },
    updateStatus (row) {
      row.status = !row.status
      this.Transaction.patch(row.codigoTransacao)
        .then(resp => {
          this.getTransaction()
        })
        .catch(err => {
          this.NotifyDanger(err.message)
        })
        .finally(() => this.$q.loading.hide())
    },
    back () {
      this.$router.go(-1)
    },
    transaction () {
      this.$router.push({ path: `transacao/novaTransacao` })
    },
    editTransaction (id, route) {
      this.$router.push({ path: `transacao/${route}/${id}` })
    }
  }
}
</script>

<style>
</style>
